----------------------------------------------------------------------
-- Finite Field Chapter 6 package (finite_field.ads)
-- 
-- Defines useful funtions for finite field operations
-- of Chapter 6 examples
---------------------------------------------------------------------

package finite_fields is
   subtype Bit is Natural range 0 .. 1;
   type bit_vector is array (natural range <>) of bit;
   n: constant natural := 20;
   m: constant natural := 239;
   k: constant natural := 8;
   s: constant natural := 3;   --s = rounded(n/k)
   logn: constant := 5;
   R: constant := 2**k;
   Minus_Inv_M: constant := 241;
   exp_k: constant := R mod m;
   exp_2k: constant := (R*R) mod m;
   subtype Digit is Natural range 0 .. 2**K - 1;
   type Digit_Vector is array (0 .. S-1) of Digit;
   function b_table(m: digit) return digit_vector;
   function mod_m_addition(x, y, m, k: natural) return natural;
   procedure csa_mod_addition(xc, xs, y: in natural; rc, rs: out natural);
   procedure csa_mod_doubling(xc, xs: in natural; rc, rs: out natural);
   function mp(x, y: natural) return natural;
   function divide_by_2(x, p: in integer) return integer;
   function Divide_By_4(X, P: in Integer) return Integer;
end finite_fields;

