----------------------------------------------------------------
-- Division by Reduction to Multiplications (reduction_multiplication.adb)
--
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Polynomials; use Polynomials;
procedure Reduction_To_Multiplications2 is
   F, G, H, E, A, Z, Y, One: Polynomial;
   Q: Natural;
   subtype Hex_Digit is Natural range 0 .. 15;

   S_Div_4: constant Natural := 32;
   --s_div_4: constant natural := 6;
   --s_div_4: constant natural := 39;

   type Hexadecimal_Representation is array(0 .. S_Div_4-1) of Hex_Digit;

   Hex_R: constant Hexadecimal_Representation := (0,8,8,7,11,7,0,14,15,5,4,11,6,11,2,3,15,0,6,7,10,9,13,14,6,13,11,5,15,9,5,5);
   --hex_r: constant hexadecimal_representation := (15,13,15,2,1,13);
   --hex_r: constant hexadecimal_representation := 
   --(0,4,9,3,2,2,12,14,6,13,8,15,0,9,4,5,6,3,2,4,14,6,6,8,7,2,0,1,14,6,8,15,1,1,8,15,11,10,1);

   subtype Bit is Natural range 0 .. 1;

   S: constant Natural := 128;
   --s: constant natural := 24;
   --s: constant natural := 156;

   type Binary_Representation is array(0 .. S-1) of Bit;
   R: Binary_Representation;
begin
   for I in 0 .. S_Div_4 - 1 loop
      R(4*I) := Hex_R(I) mod 2; Q := Hex_R(I) / 2;
      R(4*I+1) := Q mod 2; Q := Q/2;
      R(4*I+2) := Q mod 2; Q := Q/2;
      R(4*I+3) := Q mod 2;
   end loop;
   
   for I in 0 .. M loop G(I) := 0; H(I) := 0; F(I) := 0; end loop;
   F(0) := 237; F(17) := 1;
   --F(0) := 237; F(7) := 29; F(14) := 42; F(17) := 1;
   --F(0) := 2; f(12) := 1; f(97) := 1;
   
   G(1) := 1; G(5) := 47; G(9) := 230; G(15) := 117;
   H(3) := 211; H(9) := 123; H(11) := 7; H(15) := 189;
   
   --G(0) := 1; G(1) := 47; G(2) := 230; G(3) := 117;
   --H(0) := 211; H(1) := 123; H(2) := 7; H(3) := 189;
   
   --G(1) := 1; G(25) := 2; G(37) := 2; G(90) := 1;
   --for i in 0 .. 47 loop h(i) := 1; end loop;
   --for i in 48 .. 91 loop h(i) := 2; end loop;
   
   --h(0) := 237; 
   --for i in 0 .. m-1 loop h(i) := 117; end loop; h(m) := 0;
   One(0) := 1; for I in 1 .. M loop One(I) := 0; end loop; 
   ----------------------------------------------------------------------------
   E := One;
   for I in 0 .. S-1 loop
      E := Product_Mod_F(E, E, F);
      if R(S-1-I) = 1 then 
         E := Product_Mod_F(E, H, F); 
      end if;
   end loop;
   A := Product_Mod_F(E, H, F);
   E := Product(E, Invert(A(0)));
   Z := Product_Mod_F(E, G, F);
   -----------------------------------------------------------------------------
   Y := Product_Mod_F(Z, H, F);
   Put("g = "); for I in 0 .. M-1 loop Put(G(I)); Put("  "); end loop; New_Line;
   Put("h = "); for I in 0 .. M-1 loop Put(H(I)); Put("  "); end loop; New_Line;
   Put("z = "); for I in 0 .. M-1 loop Put(Z(I)); Put("  "); end loop; New_Line;
   Put("z.h = "); for I in 0 .. M-1 loop Put(Y(I)); Put("  "); end loop; New_Line;

end Reduction_To_Multiplications2;